//		Copyright © 1999  Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Screen saver class.

#ifndef FLIPSAVER_H
#define FLIPSAVER_H

#include <Bitmap.h>
#include <image.h>
#include <Message.h>
#include <ScreenSaver.h>
#include <View.h>

class FlipSaver : public BScreenSaver
{
	typedef BScreenSaver inherited;
public:
	FlipSaver(BMessage *pMsg, image_id id);
	virtual ~FlipSaver(void);
	
	// Hook functions.
	virtual void Draw(BView *pView, int32 frame);
	virtual void StartConfig(BView *pConfigView);
	virtual status_t StartSaver(BView *pView, bool preview);

private:
	FlipSaver(const FlipSaver &orig);
	FlipSaver &operator =(const FlipSaver &orig);
	
	// Draw one of the tile bitmaps.
	void FlipFlop(BView &view, bool which);
	
	// Data members.
	rgb_color mColor;
	float mTileSize;
	bool *mpArray;
	BBitmap *mpFlip;
	BBitmap *mpFlop;
};
	
#endif // FLIPSAVER_H
