//		Copyright © 1999	Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Screen saver class.

#ifndef SUCKSAVER_H
#define SUCKSAVER_H

#include <image.h>
#include <Message.h>
#include <ScreenSaver.h>
#include <View.h>

#include "RandomColor.h"

class SuckSaver : public BScreenSaver
{
	typedef BScreenSaver inherited;
public:
	SuckSaver(BMessage *pMsg, image_id id);
	virtual ~SuckSaver(void);
	
	// Hook functions.
	virtual void Draw(BView *pView, int32 frame);
	virtual void StartConfig(BView *pConfigView);
	virtual status_t StartSaver(BView *pView, bool preview);

private:
	SuckSaver(const SuckSaver &orig);
	SuckSaver &operator =(const SuckSaver &orig);
	
	// Individual particles and how to transform them.
	struct Particle {
		Particle(float angle, float radius, float velocity)
		:	mAngle(angle),
			mRadius(radius),
			mVelocity(velocity),
			mColor(RandomColor(0.5, 1.0, 0.5, 1.0))
		{
			// empty
		}
		float mAngle;
		float mRadius;
		float mVelocity;
		rgb_color mColor;
	};
	void Transform(Particle &p) const;
	BPoint Pos(const Particle &p) const;
	
	// Data members.
	BPoint mSucker;
	float mInitialRadius;
	float mInitialVelocity;
	float mGravity;

	enum {
		kMaxParticles = 200
	};
	int mNumParticles;
	Particle *mpParticles[kMaxParticles];
};
	
#endif // SUCKSAVER_H
